local minX, minY, maxX, maxY = application:getLogicalBounds()
local w = maxX - minX
local h = maxY - minY
application:setBackgroundColor(0)
 
local random=math.random
 
 
--[[
local tex1 = Texture.new("mExplosion2.png")
local tex2 = Texture.new("mExplosion3.png")
local tex3 = Texture.new("mExplosion4.png")
local tex4 = Texture.new("mExplosion5.png")
local tex5 = Texture.new("mExplosion6.png")
local tex6 = Texture.new("mExplosion7.png")
 
texs = {tex1, tex2, tex3, tex4, tex5, tex6} -- for later randomization
]]
local texs = {}

-- generate fake textures =)
for i = 1, 6 do
	local rt = RenderTarget.new(128, 128)
	rt:clear(math.random(0xffffff), 1)
	texs[i] = rt
end

local interval = 1 --change it!

local timer = Timer.new(interval)

-- particles without texture
local clearParticles = Particles.new()
stage:addChild(clearParticles)

-- for each texture create separated particle object
local explosions = {}
for i,texture in ipairs(texs) do
	local p = Particles.new()
	p:setTexture(texture)
	stage:addChild(p)
	
	explosions[i] = p
end

local m = FPSgraph.new(400, 100, nil, 0xffffff, 0.8)
stage:addChild(m)

function gomad()
	if random(0,1) == 0 then
		explode1(random(w), random(h))
	else
		explode2(random(w), random(h))
	end
end

function explode1(x,y)
	local ex2 = explosions[2]
	for i = 1,10 do
		ex2:addParticles{
			{x=minX + x,y=minY + y,size=50,alpha=0.1,ttl=random(25,50),speedAngular=5,speedX=random()-0.5,speedY=random()-0.5,decay=1.04,decayAlpha=0.97},
		}
	end
	local ex3 = explosions[3]
	for i = 1,10 do
		ex3:addParticles{
			{x=minX + x,y=minY + y,size=random(25,75),alpha=0.1,ttl=random(25,100),speedAngular=2,speedX=random()-0.5,speedY=random()-0.5,decay=1.01,decayAlpha=0.97},
		}
	end
	
	clearParticles:addParticles{
		{x=minX + x,y=minY + y,size=1,alpha=0.6,speedGrowth=10,ttl=25,decay=1.05,decayAlpha=0.84}
	}
end

function explode2(x,y)
	local ex4 = explosions[4]
	for i = 1,15 do
		ex4:addParticles{
			{x=minX + x,y=minY + y,size=50,alpha=0.3,ttl=random(25,50),speedAngular=0,speedX=random()-0.5,speedY=random()-0.5,decay=1.04,decayAlpha=0.97 }
		}
	end	
	local ex3 = explosions[3]
	for i = 1,7 do
		ex3:addParticles{
			{x=minX + x,y=minY + y,size=150,alpha=0.1,ttl=random(25,100),speedAngular=0, speedGrowth=1,speedX=random()-0.5,speedY=random()-0.5,decay=1.01,decayAlpha=0.97}
		}
	end
	local ex1 = explosions[1]
	for i = 1,20 do
		ex1:addParticles{
			{x=minX + x,y=minY + y,size=random(20,50),alpha=0.2,ttl=random(25,50),speedAngular=5,speedX=random()-0.5,speedY=random()-0.5,decay=1.05,decayAlpha=0.98}
		}
	end
	
	clearParticles:addParticles{
		{x=minX + x,y=minY + y,size=1,alpha=0.5,speedGrowth=10,ttl=50,decay=1.05,decayAlpha=0.91}
	}
end



function onEnterFrame(event)
	local dt = event.deltaTime
	m:update(dt)
end

stage:addEventListener(Event.ENTER_FRAME, onEnterFrame)
timer:addEventListener(Event.TIMER, gomad)
timer:start()